#ifndef MESH_SMOOTHER_JUN_HPP
#define MESH_SMOOTHER_JUN_HPP

#include <mesh/IMesh.hpp>
#include <scheme/IBoundaryConditionDescriptor.hpp>

#include <memory>
#include <vector>

class FunctionSymbolId;
class IZoneDescriptor;
class DiscreteFunctionVariant;

class MeshSmootherJunHandler
{
 private:
  template <size_t Dimension>
  class MeshSmootherJun;

 public:
  std::shared_ptr<const IMesh> getSmoothedMesh(
    const std::shared_ptr<const IMesh>& mesh,
    const std::vector<std::shared_ptr<const IBoundaryConditionDescriptor>>& bc_descriptor_list) const;

  std::shared_ptr<const IMesh> getSmoothedMesh(
    const std::shared_ptr<const IMesh>& mesh,
    const std::vector<std::shared_ptr<const IBoundaryConditionDescriptor>>& bc_descriptor_list,
    const FunctionSymbolId& function_symbol_id) const;

  std::shared_ptr<const IMesh> getSmoothedMesh(
    const std::shared_ptr<const IMesh>& mesh,
    const std::vector<std::shared_ptr<const IBoundaryConditionDescriptor>>& bc_descriptor_list,
    const std::vector<std::shared_ptr<const IZoneDescriptor>>& smoothing_zone_list) const;

  std::shared_ptr<const IMesh> getSmoothedMesh(
    const std::shared_ptr<const IMesh>& mesh,
    const std::vector<std::shared_ptr<const IBoundaryConditionDescriptor>>& bc_descriptor_list,
    const std::vector<std::shared_ptr<const DiscreteFunctionVariant>>& smoothing_zone_list) const;

  MeshSmootherJunHandler()                         = default;
  MeshSmootherJunHandler(MeshSmootherJunHandler&&) = default;
  ~MeshSmootherJunHandler()                        = default;
};

#endif   // MESH_SMOOTHER_JUN_HPP
